# Start a full query-result download

Launch stage: GA

`POST /api/2.0/genie/spaces/{space_id}/conversations/{conversation_id}/messages/{message_id}/attachments/{attachment_id}/downloads`

Initiates a new SQL execution and returns a `download_id` and `download_id_signature` that you can use to track the progress of the download.
 The query result is stored in an external link and can be retrieved using the Get Download Full Query Result API.
 Both `download_id` and `download_id_signature` must be provided when calling the Get endpoint. 

 ----

 ### **Warning: Databricks strongly recommends that you protect the URLs that are returned by the `EXTERNAL_LINKS` disposition.**

 When you use the `EXTERNAL_LINKS` disposition, a short-lived cloud-storage URL is generated to download the
 results. The URL contains temporary access credentials, so protect it and do not set an `Authorization` header in
 the download request.

 
 
 

 See Execute Statement for more details.

 ----

API scopes: genie

**AWS**

On AWS, the external link is a presigned URL for Amazon S3.

**Azure**

On Azure, the external link is a SAS URL for Azure Storage.

**GCP**

On GCP, the external link is a signed URL for Google Cloud Storage.

## Path parameters

- `space_id` (string, uuid, required)
  Genie space ID
  Example: `e1ef34712a29169db030324fd0e1df5f`
- `conversation_id` (string, uuid, required)
  Conversation ID
  Example: `e1ef34712a29169db030324fd0e1df5f`
- `message_id` (string, uuid, required)
  Message ID
  Example: `e1ef34712a29169db030324fd0e1df5f`
- `attachment_id` (string, uuid, required)
  Attachment ID
  Example: `e1ef34712a29169db030324fd0e1df5f`

## Returns

- `download_id` (string, optional)
  Download ID. Use this ID to track the download request in subsequent polling calls
  Example: `01eda0e7-e315-1846-84e2-79a963ffad44`
- `download_id_signature` (string, optional)
  JWT signature for the download_id to ensure secure access to query results

## Response

```json
{
  "download_id": "01eda0e7-e315-1846-84e2-79a963ffad44",
  "download_id_signature": "string"
}
```

